diff -r -u orig.kernel-4.4.126_48_default/drivers/hid/hid-core.c fixed.kernel-4.4.126_48_default/drivers/hid/hid-core.c
--- orig.kernel-4.4.126_48_default/drivers/hid/hid-core.c	2018-04-07 07:22:50.000000000 +0200
+++ fixed.kernel-4.4.126_48_default/drivers/hid/hid-core.c	2018-05-09 19:27:19.000000000 +0200
@@ -1888,6 +1888,8 @@
 	{ HID_USB_DEVICE(USB_VENDOR_ID_LENOVO, USB_DEVICE_ID_LENOVO_CUSBKBD) },
 	{ HID_BLUETOOTH_DEVICE(USB_VENDOR_ID_LENOVO, USB_DEVICE_ID_LENOVO_CBTKBD) },
 	{ HID_USB_DEVICE(USB_VENDOR_ID_LENOVO, USB_DEVICE_ID_LENOVO_TPPRODOCK) },
+	{ HID_USB_DEVICE(USB_VENDOR_ID_LENOVO, USB_DEVICE_ID_LENOVO_WIRELESS_ESSENTIAL) },
+	{ HID_USB_DEVICE(USB_VENDOR_ID_LENOVO, USB_DEVICE_ID_LENOVO_WIRELESS_PROFESSIONAL) },
 #endif
 	{ HID_USB_DEVICE(USB_VENDOR_ID_LOGITECH, USB_DEVICE_ID_MX3000_RECEIVER) },
 	{ HID_USB_DEVICE(USB_VENDOR_ID_LOGITECH, USB_DEVICE_ID_S510_RECEIVER) },
diff -r -u orig.kernel-4.4.126_48_default/drivers/hid/hid-ids.h fixed.kernel-4.4.126_48_default/drivers/hid/hid-ids.h
--- orig.kernel-4.4.126_48_default/drivers/hid/hid-ids.h	2018-04-07 07:22:50.000000000 +0200
+++ fixed.kernel-4.4.126_48_default/drivers/hid/hid-ids.h	2018-05-09 19:27:19.000000000 +0200
@@ -605,6 +605,8 @@
 #define USB_DEVICE_ID_LENOVO_CUSBKBD	0x6047
 #define USB_DEVICE_ID_LENOVO_CBTKBD	0x6048
 #define USB_DEVICE_ID_LENOVO_TPPRODOCK	0x6067
+#define USB_DEVICE_ID_LENOVO_WIRELESS_ESSENTIAL 0x60a9
+#define USB_DEVICE_ID_LENOVO_WIRELESS_PROFESSIONAL 0x609b
 
 #define USB_VENDOR_ID_LG		0x1fd2
 #define USB_DEVICE_ID_LG_MULTITOUCH	0x0064
diff -r -u orig.kernel-4.4.126_48_default/drivers/hid/hid-lenovo.c fixed.kernel-4.4.126_48_default/drivers/hid/hid-lenovo.c
--- orig.kernel-4.4.126_48_default/drivers/hid/hid-lenovo.c	2018-04-07 07:22:50.000000000 +0200
+++ fixed.kernel-4.4.126_48_default/drivers/hid/hid-lenovo.c	2018-05-09 19:27:19.000000000 +0200
@@ -53,6 +53,52 @@
 	0x2a, 0xff, 0xff,	/*  Usage Maximum (65535)		*/
 };
 
+static void fix_lenovo_hid_descriptor_primax(__u8 *rdesc)
+{
+   __u8 desc[80];
+	int i=0;
+
+	desc[22] = rdesc[24];
+	desc[23] = rdesc[25];
+	desc[24] = rdesc[22];
+	desc[25] = rdesc[23];
+	for (i=22;i<=25;i++) {
+		rdesc[i] = desc[i];
+	}
+	desc[28] = rdesc[36];
+	desc[29] = rdesc[37];
+	desc[30] = rdesc[34];
+	desc[31] = rdesc[35];
+	desc[32] = rdesc[28];
+	desc[33] = rdesc[29];
+	desc[34] = rdesc[30];
+	desc[35] = rdesc[31];
+	desc[36] = rdesc[32];
+	desc[37] = rdesc[33];
+	for (i=28;i<=37;i++) {
+		rdesc[i] = desc[i];
+	}
+	desc[46] = rdesc[60];
+	desc[47] = rdesc[61];
+	desc[48] = rdesc[58];
+	desc[49] = rdesc[59];
+	desc[50] = rdesc[46];
+	desc[51] = rdesc[47];
+	desc[52] = rdesc[48];
+	desc[53] = rdesc[49];
+	desc[54] = rdesc[50];
+	desc[55] = rdesc[56];
+	desc[56] = rdesc[57];
+	desc[57] = rdesc[51];
+	desc[58] = rdesc[52];
+	desc[59] = rdesc[53];
+	desc[60] = rdesc[54];
+	desc[61] = rdesc[55];
+	for (i=46;i<=61;i++) {
+		rdesc[i] = desc[i];
+	}
+}
+
 static __u8 *lenovo_report_fixup(struct hid_device *hdev, __u8 *rdesc,
 		unsigned int *rsize)
 {
@@ -69,6 +115,18 @@
 			rdesc[152] = 0x00;
 		}
 		break;
+	case USB_DEVICE_ID_LENOVO_WIRELESS_PROFESSIONAL:
+		if (*rsize == 80) {
+		// Not the keyboard if the rdesc[3] is not 0x06
+			if (rdesc[3] != 0x06) return rdesc;
+			fix_lenovo_hid_descriptor_primax(rdesc);
+		}
+		break;
+	case USB_DEVICE_ID_LENOVO_WIRELESS_ESSENTIAL:
+		if (*rsize == 65) {
+		fix_lenovo_hid_descriptor_primax(rdesc);
+		}
+		break;
 	}
 	return rdesc;
 }
@@ -873,6 +931,8 @@
 	{ HID_USB_DEVICE(USB_VENDOR_ID_LENOVO, USB_DEVICE_ID_LENOVO_CUSBKBD) },
 	{ HID_BLUETOOTH_DEVICE(USB_VENDOR_ID_LENOVO, USB_DEVICE_ID_LENOVO_CBTKBD) },
 	{ HID_USB_DEVICE(USB_VENDOR_ID_LENOVO, USB_DEVICE_ID_LENOVO_TPPRODOCK) },
+	{ HID_USB_DEVICE(USB_VENDOR_ID_LENOVO, USB_DEVICE_ID_LENOVO_WIRELESS_ESSENTIAL) },
+	{ HID_USB_DEVICE(USB_VENDOR_ID_LENOVO, USB_DEVICE_ID_LENOVO_WIRELESS_PROFESSIONAL) },
 	{ }
 };
 
